$hDLL = DllOpen("LevenshteinDistance.dll")
ConsoleWrite(CompTstr("Text", "Test") & @CRLF)
DllClose($hDLL)

func CompTstr($s, $t)
   local $n, $m
   $n = StringLen($s)
   $m = StringLen($t)
   if $n < $m then $n = $m
    $arDLL = DllCall($hDLL, "int", "LevenshteinDistance", "wstr", $s, "wstr", $t)
    ConsoleWrite (StringFormat ("error: %d\n", @error))
    ConsoleWriteArray ($arDLL, "arDLL")
    If IsArray($arDLL) Then Return ($n - $arDLL[0]) / $n
endfunc


;

Func ConsoleWriteArray (ByRef Const $array, $sArrayName = "")

	Local $cnColumns
	Local $cnDimension
	Local $cnRows
	Local $cnElements


	If (not IsArray ($array)) Then
		ConsoleWrite (StringFormat ("!--- ConsoleWriteArray - Fehler: %s ist kein Array!\n", $sArrayName))
		Return 0
	EndIf

	$cnDimension	= UBound ($array, 0)

	If ($cnDimension > 3) Then
		ConsoleWrite (StringFormat ("!--- ConsoleWriteArray - Fehler: %d\n", $sArrayName, $cnDimension))
		ConsoleWrite (StringFormat ("!--- Max. Anzahl Dimensionen: %d\n", 3))
		ConsoleWrite (StringFormat ("!--- %s - Anzahl Dimensionen: %d\n", $sArrayName, $cnDimension))
		Return 0
	EndIf

	ConsoleWrite (StringFormat ("--- Arrayvariable %s\n--- Anzahl Dimensionen: %d\n", $sArrayName, $cnDimension))

	$cnRows		= UBound ($array, 1)
	$cnColumns	= UBound ($array, 2)
	$cnElements	= UBound ($array, 3)

	Switch ($cnDimension)

		Case 1
			;...
			For $i = 0 To $cnRows - 1

				ConsoleWrite (StringFormat ("; %s [%d] = %s\n", $sArrayName, $i, $array[$i]))
			Next
		Case 2
			;...
			For $i = 0 To $cnRows - 1

				For $j = 0 To $cnColumns - 1

					ConsoleWrite (StringFormat ("; %s [%d][%d] = %s\n", $sArrayName, $i, $j, $array[$i][$j]))
				Next
			Next
		Case 3
			;...
			For $i = 0 To $cnRows - 1

				For $j = 0 To $cnColumns - 1

					For $k = 0 To $cnElements - 1

						ConsoleWrite (StringFormat ("; %s [%d][%d][%d] = %s\n", $sArrayName, $i, $j, $k, $array[$i][$j][$k]))
					Next
				Next
			Next
		Case Else
			;...
	EndSwitch

	ConsoleWrite (StringFormat ("----------------------------\n\n", 0))

EndFunc

; End Of File 

